Description

Werner and Mario ask whether it could make sense to have an IsRadical function for ideals; can this be determined significantly

more cheaply (at least in some cases) than actually computing the radical.

Related issues:

Related to CoCoALib - Feature #796: CoCoALib function for radical (or SqFree)... Closed 05 Nov 2015

Related to CoCoA-5 - Slug #948: radical is slow (compared to singular) on the... Closed 18 Oct 2016

History

#1 - 18 Oct 2016 14:56 - John Abbott

- Related to Feature #796: CoCoALib function for radical (or SqFree) of a polynomial added

#2 - 18 Oct 2016 14:59 - John Abbott

- Related to Slug #948: radical is slow (compared to singular) on these examples added

#3 - 18 Oct 2016 15:03 - Anna Maria Bigatti

There is now "IsRadical" for 0-dimensional ideals.  (and it's in our paper in progress ;-)

I've just realized I forgot to write the manual.... I write it now.

#4 - 18 Oct 2016 15:19 - Anna Maria Bigatti

Apart from 0-dim (already implemented),  and monomial,  how can you determine it?

#5 - 18 Oct 2016 15:51 - John Abbott

- Status changed from New to In Progress

- % Done changed from 0 to 10

The crude idea was just to run the usual code for computing the radical, and if at some point we determine with certainty that it is (or is not) radical

then the code simply returns the relevant boolean.  Of course, in many cases there may be only a small saving compared to computing the radical

itself, but in some cases there may be a significant saving....?

#6 - 18 Oct 2016 16:02 - John Abbott

I wonder if a probabilistic approach could work.  If the ideal is 0-dim, the speed is adequate.  If not, perhaps we could assign random values to certain

indets until it is 0-dim (or anyway low dim); then if the image is radical the original probably was too?  Presumably several random assignments

should be made before accepting the result?

Would this work?  Would it be usefully faster?  Is my assertion "probably was too" correct (or at least vaguely correct)?

#7 - 18 Oct 2016 16:06 - Anna Maria Bigatti

John Abbott wrote:
I wonder if a probabilistic approach could work.  If the ideal is 0-dim, the speed is adequate.  If not, perhaps we could assign random values to

certain indets until it is 0-dim (or anyway low dim); then if the image is radical the original probably was too?  Presumably several random

assignments should be made before accepting the result?

Would this work?  Would it be usefully faster?  Is my assertion "probably was too" correct (or at least vaguely correct)?

 

Next paper ;-)

#8 - 21 Oct 2016 14:24 - John Abbott

I think there could be problems with removing indets by giving them values: if there is an embedded 0-dim component then this will (almost certainly)

be lost when removing indets (unless we happen to pick values corresponding to the coordindates of the 0-dim component).

:-/  :-(

#9 - 25 Feb 2020 17:16 - John Abbott

- Target version changed from CoCoALib-1.0 to CoCoALib-0.99800

#10 - 06 Oct 2020 15:45 - John Abbott

- Target version changed from CoCoALib-0.99800 to CoCoALib-0.99850

#11 - 23 Jan 2024 22:13 - John Abbott

- Target version changed from CoCoALib-0.99850 to CoCoALib-0.99880

I think my idea might not work in general.

Let I := ideal(x+y^2)  then I is radical.  But if I add an extra generator x then I+ideal(x) = ideal(x,y^2) which

is not radical.

Let J := intersection(ideal(x,y^2), ideal(x+y+1)).  Then J is not radical, but J+ideal(y) = ideal(y, x^2+x) which is radical.

I fear this shows that idea does not work (at least not in its simplest form).
